'From MIT Squeak 0.9.4 (June 1, 2003) [No updates present.] on 1 February 2008 at 11:13:47 am'!
InterpreterPlugin subclass: #PangoPlugin2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Primitives-Plugins'!
!PangoPlugin2 commentStamp: 'jm 1/24/2008 07:38' prior: 0!
This plugin is used to measure and display UTF-8 strings using Pango as the underlying rendering engine.
!


!PangoPlugin2 methodsFor: 'primitives' stamp: 'jm 1/23/2008 13:24'!
primitiveDrawString

	| utf8Oop utf8 w h bitmapOop bitmapPtr utf8Length result |
	self export: true.
	self var: 'utf8' declareC: 'char *utf8'.
	self var: 'bitmapPtr' declareC: 'void *bitmapPtr'.

	utf8Oop _ interpreterProxy stackValue: 3.
	utf8 _ self cString: utf8Oop.
	w _ interpreterProxy stackIntegerValue: 2.
	h _ interpreterProxy stackIntegerValue: 1.
	bitmapOop _ interpreterProxy stackValue: 0.
	bitmapPtr _ self cWordsPtr: bitmapOop minSize: w * h.
	interpreterProxy failed ifTrue: [^ nil].

	utf8Length _ interpreterProxy stSizeOf: utf8Oop.
	self cCode: 'pango2DrawString(utf8, utf8Length, &w, &h, bitmapPtr)'.

	result _ interpreterProxy makePointwithxValue: w yValue: h.
	interpreterProxy pop: 5 thenPush: result.
	^ 0
! !

!PangoPlugin2 methodsFor: 'primitives' stamp: 'jm 2/1/2008 10:47'!
primitiveMeasureString

	| utf8Oop utf8 utf8Length w h result |
	self export: true.
	self var: 'utf8' declareC: 'char *utf8'.

	utf8Oop _ interpreterProxy stackValue: 0.
	utf8 _ self cString: utf8Oop.
	interpreterProxy failed ifTrue: [^ nil].

	w _ h _ 0.
	utf8Length _ interpreterProxy stSizeOf: utf8Oop.
	self cCode: 'pango2MeasureString(utf8, utf8Length, &w, &h, (void *) 0)'.

	result _ interpreterProxy makePointwithxValue: w yValue: h.
	interpreterProxy pop: 2 thenPush: result.
	^ 0
! !

!PangoPlugin2 methodsFor: 'primitives' stamp: 'jm 2/1/2008 10:48'!
primitiveMeasureStringDetails

	| utf8Oop utf8 utf8Length  resultOop resultPtr w h result |
	self export: true.
	self var: 'utf8' declareC: 'char *utf8'.
	self var: 'resultPtr' declareC: 'int *resultPtr = 0'.

	utf8Oop _ interpreterProxy stackValue: 1.
	utf8 _ self cString: utf8Oop.
	resultOop _ interpreterProxy stackValue: 0.
	resultPtr _ self cWordsPtr: resultOop minSize: 9.
	interpreterProxy failed ifTrue: [^ nil].

	w _ h _ 0.
	utf8Length _ interpreterProxy stSizeOf: utf8Oop.
	self cCode: 'pango2MeasureString(utf8, utf8Length, &w, &h, resultPtr)'.

	result _ interpreterProxy makePointwithxValue: w yValue: h.
	interpreterProxy pop: 3 thenPush: result.
	^ 0
! !

!PangoPlugin2 methodsFor: 'primitives' stamp: 'jm 1/20/2008 19:46'!
primitiveSetColors

	| fgRed fgGreen fgBlue bgRed bgGreen bgBlue mapBGToTransparent |
	self export: true.

	fgRed _ interpreterProxy stackIntegerValue: 6.
	fgGreen _ interpreterProxy stackIntegerValue: 5.
	fgBlue _ interpreterProxy stackIntegerValue: 4.
	bgRed _ interpreterProxy stackIntegerValue: 3.
	bgGreen _ interpreterProxy stackIntegerValue: 2.
	bgBlue _ interpreterProxy stackIntegerValue: 1.
	mapBGToTransparent _ interpreterProxy booleanValueOf: (interpreterProxy stackValue: 0).
	interpreterProxy failed ifTrue: [^ nil].

	self cCode: 'pango2SetColors(fgRed, fgGreen, fgBlue, bgRed, bgGreen, bgBlue, mapBGToTransparent)'.

	interpreterProxy pop: 7.
	^ 0
! !

!PangoPlugin2 methodsFor: 'primitives' stamp: 'jm 1/19/2008 21:17'!
primitiveSetFont

	| fontName fontSize boldFlag italicFlag antiAliasFlag |
	self export: true.
	self var: 'fontName' declareC: 'char fontName[200]'.

	self copyString: (interpreterProxy stackValue: 4) into: fontName max: 200.
	fontSize _ interpreterProxy stackIntegerValue: 3.
	boldFlag _ interpreterProxy booleanValueOf: (interpreterProxy stackValue: 2).
	italicFlag _ interpreterProxy booleanValueOf: (interpreterProxy stackValue: 1).
	antiAliasFlag _ interpreterProxy booleanValueOf: (interpreterProxy stackValue: 0).
	interpreterProxy failed ifTrue: [^ nil].

	self cCode: 'pango2SetFont(fontName, fontSize, boldFlag, italicFlag, antiAliasFlag)'.

	interpreterProxy pop: 5.
	^ 0
! !

!PangoPlugin2 methodsFor: 'primitives' stamp: 'jm 1/20/2008 23:03'!
primitiveSetLanguage

	| lang |
	self export: true.
	self var: 'lang' declareC: 'char lang[100]'.

	self copyString: (interpreterProxy stackValue: 0) into: lang max: 100.
	interpreterProxy failed ifTrue: [^ nil].

	self cCode: 'pango2SetLanguage(lang)'.

	interpreterProxy pop: 1.
	^ 0
! !


!PangoPlugin2 methodsFor: 'utility' stamp: 'jm 1/19/2008 21:06'!
cString: stringOop
	"Return a C char * pointer into the given Squeak string object."
	"Warning: A Squeak string is not necessarily null-terminated."
	"Warning: the resulting pointer may become invalid after the next garbage collection and should only be using during the current primitive call."

	self inline: false.
	self returnTypeC: 'char *'.

	((interpreterProxy isIntegerObject: stringOop) or:
	 [(interpreterProxy isBytes: stringOop) not]) ifTrue: [
		interpreterProxy success: false.
		^ 0].

	^ self cCoerce: (interpreterProxy firstIndexableField: stringOop) to: 'char *'
! !

!PangoPlugin2 methodsFor: 'utility' stamp: 'jm 1/24/2008 07:01'!
cWordsPtr: oop minSize: minSize
	"Return a C pointer to the first indexable field of oop, which must be a words object of at least the given size."
	"Warning: the resulting pointer may become invalid after the next garbage collection and should only be using during the current primitive call."

	self inline: false.
	self returnTypeC: 'void *'.

	interpreterProxy success:
		((interpreterProxy isIntegerObject: oop) not and:
		 [(interpreterProxy isWords: oop) and:
		 [(interpreterProxy stSizeOf: oop) >= minSize]]).
	interpreterProxy failed ifTrue: [^ 0].
	^ self cCoerce: (interpreterProxy firstIndexableField: oop) to: 'void *'
! !

!PangoPlugin2 methodsFor: 'utility' stamp: 'jm 1/19/2008 21:06'!
copyString: stringOop into: stringPtr max: maxChars
	"Copy the Squeak string into a temporary buffer and add a terminating null byte. Fail if there is not sufficent space in the buffer."

	| srcPtr count |
	self inline: false.
	self var: 'stringPtr' declareC: 'char *stringPtr'.
	self var: 'srcPtr' declareC: 'char *srcPtr'.

	((interpreterProxy isIntegerObject: stringOop) or:
	 [(interpreterProxy isBytes: stringOop) not]) ifTrue: [
		interpreterProxy success: false.
		^ 0].

	count _ interpreterProxy stSizeOf: stringOop.
	count < maxChars ifFalse: [
		interpreterProxy success: false.
		^ 0].

	srcPtr _ self cCoerce: (interpreterProxy firstIndexableField: stringOop) to: 'char *'.
	1 to: count do: [:i | self cCode: '*stringPtr++ = *srcPtr++'].
	self cCode: '*stringPtr = 0'.
	^ 0
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PangoPlugin2 class
	instanceVariableNames: ''!

!PangoPlugin2 class methodsFor: 'translation' stamp: 'jm 1/23/2008 13:05'!
declareCVarsIn: aCCodeGenerator
	"self translate"

	super declareCVarsIn: aCCodeGenerator.
	aCCodeGenerator cExtras: '
void pango2DrawString(char *utf8, int utf8Length, int *wPtr, int *hPtr, unsigned char *bitmapPtr);
void pango2MeasureString(char *utf8, int utf8Length, int *wPtr, int *hPtr, int *layoutDetailsPtr);
void pango2SetColors(int fgRed, int fgGreen, int fgBlue, int bgRed, int bgGreen, int bgBlue, int mapBGToTransparent);
void pango2SetFont(char *fontName, int fontSize, int boldFlag, int italicFlag, int antiAliasFlag);
void pango2SetLanguage(char* lang);
'.
! !


!PangoPlugin2 class methodsFor: 'utilities' stamp: 'jm 1/23/2008 13:31'!
drawString: utf8 on: f

	f unhibernate.
	self assert: [f depth = 32].
	^ self primDrawString: utf8 w: f width h: f height bits: f bits
! !

!PangoPlugin2 class methodsFor: 'utilities' stamp: 'jm 1/24/2008 16:21'!
setColorFG: fgColor BG: bgColor bgTransparent: aBoolean
	"Set my foreground and background colors. The background color is used for antialiasing. If bgTransparent is true the background is mapped to transparent where no text appears."

	self primSetColorfgRed: fgColor r255 fgGreen: fgColor g255 fgBlue: fgColor b255
					bgRed: bgColor r255 bgGreen: bgColor g255 bgBlue: bgColor b255
		mapBGToTransparent: aBoolean.
! !


!PangoPlugin2 class methodsFor: 'testing' stamp: 'jm 1/24/2008 19:23'!
test1
	"self test1"

	| s f extent |
	s _ UTF8 fromMacRoman: 'ABC abc 123'.
	self primSetFont: 'Times' size: 21 bold: false italic: false antialias: true.
	self primSetColorfgRed: 255 fgGreen: 255 fgBlue: 255 bgRed: 100 bgGreen: 20 bgBlue: 120 mapBGToTransparent: false.
	f _ Form extent:(self primMeasureString: s) depth: 32.
	extent _ self drawString: s on: f.
	(f magnifyBy: 4) displayOn: Display at: 10@10 rule: Form paint.
	^ extent
! !

!PangoPlugin2 class methodsFor: 'testing' stamp: 'jm 1/24/2008 19:23'!
test2
	"self test2"

	| f y |
	self primSetFont: 'Times' size: 36 bold: false italic: false antialias: true.
	self setColorFG: Color black BG: Color white bgTransparent: false.
	y _ 5.
	self testStrings do: [:s |
		f _ Form extent: 800@50 depth: 32.
		self drawString: s on: f.
		f displayOn: Display at: 5@y rule: Form paint.
		y _ y + f height].
! !

!PangoPlugin2 class methodsFor: 'testing' stamp: 'jm 1/24/2008 19:23'!
test3
	"Display fillWhite. self test3"

	| y details extent f |
	self primSetFont: 'Times' size: 36 bold: false italic: false antialias: true.
	self setColorFG: Color black BG: Color white bgTransparent: false.
	y _ 5.
	^ self testStrings collect: [:s |
		details _ Bitmap new: 9.
		extent _ self primMeasureString: s details: details.
		f _ Form extent: extent depth: 32.
		self drawString: s on: f.
		Display fill: ((5@y) - 1 extent: extent + 2) fillColor: Color green.
		f displayOn: Display at: 5@y rule: Form paint.
		Display fill: ((5@(y + details last)) extent: (f width@1)) fillColor: (Color yellow alpha: 0.2).
		y _ y + extent y + 5.
		Array with: extent with: details asArray]

! !

!PangoPlugin2 class methodsFor: 'testing' stamp: 'jm 1/24/2008 16:24'!
testArabic
	"self testArabic"

	| s f extent |
	self primSetFont: 'Verdana' size: 24 bold: false italic: false antialias: true.
	self setColorFG: Color black BG: Color white bgTransparent: false.
	s _ 'أنا قادر على أكل الزجاج و هذا لا يؤلمني.'.
	f _ Form extent: 600@50 depth: 32.
	extent _ self drawString: s on: f.
	f displayOn: Display at: 10@10 rule: Form paint.

	f _ Form extent: (self primMeasureString: s) depth: 32.
	extent _ self drawString: s on: f.
	f displayOn: Display at: 10@100 rule: Form paint.

	^ extent
! !

!PangoPlugin2 class methodsFor: 'testing' stamp: 'jm 1/24/2008 16:24'!
testArabic2
	"self testArabic2 asArray (1 5 486 37 0 0 488 38 31)"

	| s f extent details |
	self primSetFont: 'Verdana' size: 24 bold: false italic: false antialias: true.
	self setColorFG: Color black BG: Color white bgTransparent: false.
	s _ 'أنا قادر على أكل الزجاج و هذا لا يؤلمني.'.
	f _ Form extent: 600@50 depth: 32.
	extent _ self drawString: s on: f.
	f displayOn: Display at: 10@10 rule: Form paint.

	f _ Form extent: (self primMeasureString: s) depth: 32.
	extent _ self drawString: s on: f.
	f displayOn: Display at: 10@100 rule: Form paint.

	details _ Bitmap new: 9.
	extent _ self primMeasureString: s details: details.
	^ details
! !

!PangoPlugin2 class methodsFor: 'testing' stamp: 'jm 1/24/2008 07:32'!
testHanSubstitution: lang
	"See if the language setting changes the rendering of certain Chinese/Japanese/Korean characters."
	"self testHanSubstitution: 'en'"
	"self testHanSubstitution: 'ko'"
	"self testHanSubstitution: 'ja'"
	"self testHanSubstitution: 'zh'"

	| s1 s2 y extent f |
	s1 _ '"grass" (U+8349): 草'.
	s2 _ '"one" in Chinese, Japanese, and Korean: 壹, 壱, 一'.

	self primSetLanguage: lang.
	self primSetFont: 'serif' size: 24 bold: false italic: true antialias: true.
	y _ 5.
	{s1. s2} do: [:s |
		extent _ self primMeasureString: s.
		f _ Form extent: extent depth: 32.
		self drawString: s on: f.
		f displayOn: Display at: 5@y rule: Form paint.
		y _ y + f height].
! !

!PangoPlugin2 class methodsFor: 'testing' stamp: 'jm 1/23/2008 12:31'!
testStrings
	"Answer a set of test strings in various languages/character sets."

	^ 'Ég get etið gler án þess að meiða mig.
أنا قادر على أكل الزجاج و هذا لا يؤلمني.
मैं काँच खा सकता हूँ, मुझे उस से कोई पीडा नहीं होती.
איך קען עסן גלאָז און עס טוט מיר נישט װײ
我能吞下玻璃而不伤身体。
私はガラスを食べられます。それは私を傷つけません。
나는 유리를 먹을 수 있어요. 그래도 아프지 않아요
ฉันกินกระจกได้ แต่มันไม่ทำให้ฉันเจ็บ' lines
! !

!PangoPlugin2 class methodsFor: 'testing' stamp: 'jm 1/24/2008 07:30'!
timeClearBG: clearBG antiAlias: antiAliasFlag
	"Measure rendering time with various options. The first run for a given style make take longer as the fonts are loaded so the timing for the first runs should be ignored. It takes 20% to 30% more time to clear the background, except in the non-anti-alias case when the background is already transparent."
	"[self timeClearBG: false antiAlias: true] msecs"
	"[self timeClearBG: true antiAlias: true] msecs"
	"[self timeClearBG: false antiAlias: false] msecs"
	"[self timeClearBG: true antiAlias: false] msecs"

	| bg y extent f |
	bg _ clearBG & antiAliasFlag not ifTrue: [0] ifFalse: [255].
	self primSetColorfgRed: 0 fgGreen: 0 fgBlue: 1
		bgRed: bg bgGreen: bg bgBlue: bg
		mapBGToTransparent: clearBG.

	self primSetFont: 'Helvetica Neue' size: 18 bold: false italic: false antialias: antiAliasFlag.
	y _ 5.
	100 timesRepeat: [
		self testStrings do: [:s |
			extent _ self primMeasureString: s.
			f _ Form extent: extent depth: 32.
			self drawString: s on: f.
			"f displayOn: Display at: 5@y rule: Form paint."
			y _ y + f height]].
! !


!PangoPlugin2 class methodsFor: 'primitives' stamp: 'jm 1/23/2008 13:27'!
primDrawString: utf8 w: w h: h bits: aBitmap
	"Draw a UTF-8 string onto a 32-bit deep bitmap of the given dimensions. Use the current font and colors. Return the extent of the rendered string (even if it is larger or smaller than the bitmap)."

	<primitive: 'primitiveDrawString' module: 'PangoPlugin2'>
	self primitiveFailed
! !

!PangoPlugin2 class methodsFor: 'primitives' stamp: 'jm 1/19/2008 21:07'!
primMeasureString: utf8
	"Return the extent of the given UTF-8 string when rendered with the current font."

	<primitive: 'primitiveMeasureString' module: 'PangoPlugin2'>
	self primitiveFailed
! !

!PangoPlugin2 class methodsFor: 'primitives' stamp: 'jm 2/1/2008 10:48'!
primMeasureString: utf8 details: aBitmap
	"Return the extent of the given UTF-8 string when rendered with the current font. Store the layout details into the given nine-element bitmap. On return, this bitmap contains:
	inkRect left, top, width, height
	logicalRect left, top, width, height
	baseline
All numbers are pixel offsets from the top-left corner of the Form into which the string will be rendered."

	<primitive: 'primitiveMeasureStringDetails' module: 'PangoPlugin2'>
	self primitiveFailed
! !

!PangoPlugin2 class methodsFor: 'primitives' stamp: 'jm 1/24/2008 07:37'!
primSetColorfgRed: r1 fgGreen: g1 fgBlue: b1 bgRed: r2 bgGreen: g2 bgBlue: b2 mapBGToTransparent: aBoolean
	"Set the text foreground and background colors. If mapBGToTransparent is true, then the background color is mapped to transparent (but it is still used for anti-aliasing). This typically adds 20-30% to the rendering time--more for larger fonts."

	<primitive: 'primitiveSetColors' module: 'PangoPlugin2'>
	self primitiveFailed
! !

!PangoPlugin2 class methodsFor: 'primitives' stamp: 'jm 1/19/2008 21:07'!
primSetFont: fontName size: fontSize bold: boldFlag italic: italicFlag antialias: antialiasFlag
	"Set the font characteristics to be used on subsequent calls to draw or measure strings."

	<primitive: 'primitiveSetFont' module: 'PangoPlugin2'>
	self primitiveFailed
! !

!PangoPlugin2 class methodsFor: 'primitives' stamp: 'jm 1/24/2008 07:36'!
primSetLanguage: aString
	"Set the language to the given ISO-3066 language tag."

	<primitive: 'primitiveSetLanguage' module: 'PangoPlugin2'>
	self primitiveFailed
! !
